package com.zanxiang.common.enums;

import lombok.Getter;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 支付设备类型
 *
 * @author xufeng
 * @date 2022/6/16 18:07
 */
@Getter
public enum PayDeviceEnum {
    PC(1, "pc", "Pc端支付"),
    H5(2, "h5", "Wap端支付"),
    APP(3, "app", "App支付"),
    MP(4, "mp", "小程序");

    private Integer code;

    private String name;

    private String desc;

    PayDeviceEnum(Integer code, String name, String desc) {
        this.code = code;
        this.name = name;
        this.desc = desc;
    }

    public static String getCodeByNum(Integer code) {
        PayDeviceEnum[] values = PayDeviceEnum.values();
        for (int i = 0; i < values.length; i++) {
            if (values[i].getCode().equals(code))
                return values[i].getName();
        }
        return "";
    }

    public static String getDescByNum(Integer code) {
        PayDeviceEnum[] values = PayDeviceEnum.values();
        for (int i = 0; i < values.length; i++) {
            if (values[i].getCode().equals(code))
                return values[i].getDesc();
        }
        return "";
    }


    public static String getSqlCode(Integer code) {
        return "," + code + ",";
    }

    public static String getDesc(String obj) {
        List<String> Desc = new ArrayList<>(10);
        String str = obj.substring(1, obj.length() - 1);
        String[] strArr = str.split(",");
        for (int i = 0; i < strArr.length; i++) {
            String name = PayDeviceEnum.getDescByNum(Integer.valueOf(strArr[i]));
            Desc.add(name);
        }
        return Desc.stream().collect(Collectors.joining(","));
    }
}
