package com.zanxiang.common.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Arrays;
import java.util.Objects;

/**
 * @author : lingfeng
 * @time : 2022-06-07
 * @description : 手机验证码类型枚举
 */
@Getter
@AllArgsConstructor
public enum SmsTypeEnum {

    /**
     * 注册
     */
    SMS_REG(1, "注册"),

    /**
     * 注册
     */
    SMS_LOGIN(2, "登陆"),

    /**
     * 修改密码
     */
    SMS_MODIFY(3, "修改密码"),

    /**
     * 身份验证
     */
    SMS_ID_VERIFY(4, "身份验证"),

    /**
     * 找回密码
     */
    SMS_FIND_PWD(5, "找回密码"),

    /**
     * 绑定手机
     */
    SMS_BIND(6, "绑定手机"),

    /**
     * 其他,增加时这个放最后
     */
    SMS_OTHER(7, "其他,增加时这个放最后");

    /**
     * 类型
     */
    private Integer type;

    /**
     * 描述
     */
    private String describe;

    /**
     * 根据type获取枚举
     *
     * @return : 返回枚举对象
     */
    public static SmsTypeEnum getByType(Integer type) {
        if (type == null) {
            return null;
        }
        return Arrays.stream(SmsTypeEnum.values())
                .filter(e -> Objects.equals(e.getType(), type))
                .findFirst().orElse(null);
    }
}
