package com.zanxiang.common.utils;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.util.Date;

/**
 * @Author wcc
 * @Date 2020/9/17 19:54
 * @Version 1.0
 * @Description
 */
public class NumberUtil {

    public static Long toLong(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Integer) {
            return ((Integer) obj).longValue();
        }
        if (obj instanceof Long) {
            return (Long) obj;
        }
        if (obj instanceof String) {
            return new BigDecimal((String) obj).longValue();
        }
        if (obj instanceof BigDecimal) {
            return ((BigDecimal) obj).longValue();
        }
        if (obj instanceof BigInteger) {
            return ((BigInteger) obj).longValue();
        }
        throw new RuntimeException("unknown data type! Class: " + obj.getClass());
    }

    public static Integer toInt(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Integer) {
            return (Integer) obj;
        }
        if (obj instanceof Long) {
            return ((Long) obj).intValue();
        }
        if (obj instanceof String) {
            return new BigDecimal((String) obj).intValue();
        }
        if (obj instanceof BigDecimal) {
            return ((BigDecimal) obj).intValue();
        }
        if (obj instanceof BigInteger) {
            return ((BigInteger) obj).intValue();
        }
        throw new RuntimeException("unknown data type! Class: " + obj.getClass());
    }

    public static Boolean toBool(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Boolean) {
            return (Boolean) obj;
        }
        if (obj instanceof String) {
            String temp = (String) obj;
            temp = temp.toLowerCase();
            if (temp.equals("true")) {
                return true;
            }
            if (temp.equals("false")) {
                return false;
            }
            try {
                return new BigDecimal(temp).compareTo(BigDecimal.ZERO) != 0;
            } catch (Exception e) {
                throw new RuntimeException("Failed transform String to Boolean! value: " + temp);
            }
        }
        return toLong(obj) != 0;
    }

    public static LocalDateTime toLocalDateTime(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Date) {
            return DateUtils.dateToLocalDateTime((Date) obj);
        }
        if (obj instanceof LocalDateTime) {
            return (LocalDateTime) obj;
        }
        if (obj instanceof LocalDate) {
            return LocalDateTime.of((LocalDate) obj, LocalTime.MIDNIGHT);
        }
        throw new RuntimeException("unknown data type! Class: " + obj.getClass());
    }
}
