package com.zanxiang.manage.domain.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * @author : lingfeng
 * @time : 2022-06-29
 * @description : 用户实名认证信息
 */
@Data
public class UserNameAuthVO {

    /**
     * 玩家id
     */
    @ApiModelProperty(notes = "玩家id")
    private Long userId;

    /**
     * 玩家账号
     */
    @ApiModelProperty(notes = "玩家账号")
    private String username;

    /**
     * 玩家昵称
     */
    @ApiModelProperty(notes = "玩家昵称")
    private String nickname;

    /**
     * 注册时间
     */
    @ApiModelProperty(notes = "注册时间")
    private LocalDateTime createTime;

    /**
     * 实名认证平台, 1 国家网络防沉迷
     */
    @ApiModelProperty(notes = "实名认证平台, 1 国家网络防沉迷")
    private Integer authPlatform;

    /**
     * 真实姓名
     */
    @ApiModelProperty(notes = "真实姓名")
    private String realName;

    /**
     * 中宣部PI
     */
    @ApiModelProperty(notes = "中宣部PI")
    private String zxbPi;

    /**
     * 实名认证时间
     */
    @ApiModelProperty(notes = "创建时间, 实名认证时间")
    private LocalDateTime authTime;

    /**
     * 更新时间
     */
    @ApiModelProperty(notes = "更新时间")
    private LocalDateTime updateTime;

}
