package com.zanxiang.sdk.domain.params;

import com.fasterxml.jackson.annotation.JsonAlias;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotBlank;

/**
 * @author : lingfeng
 * @time : 2022-06-14
 * @description : 修改密码参数
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class UpdatePasswordParam extends CommonParam{

    /**
     * 用户token
     */
    @ApiModelProperty(notes = "token")
    @JsonAlias("verify_token")
    @NotBlank(message = "注册用户名字不可为空")
    private String token;

    /**
     * 用户名
     */
    @ApiModelProperty(notes = "用户名")
    @JsonAlias("mem-username")
    @NotBlank(message = "用户名字不可为空")
    private String username;

    /**
     * 新密码
     */
    @ApiModelProperty(notes = "新密码")
    @NotBlank(message = "新密码不可为空")
    @JsonAlias("mem-password")
    private String password;
}
